#!/bin/bash
#/**
#        mountimage
#@brief  Monta imagen sincronizable en el repositorio con permisos de escritura
#@param 1 imagen
#@param 2 extension [ img|diff ] opcional, por defecto img
#@return  Directorio de montaje de la imagen.
#@exception OG_ERR_FORMAT     # 1 formato incorrecto.
#@exception OG_ERR_NOTFOUND # 2 Fichero o dispositivo no encontrado
#@exception OG_ERR_DONTSYNC_IMAGE  #71 Imagen no sincronizable (es monolitica)
#@exception OG_ERR_DONTMOUNT_IMAGE # 70 Error al montar una imagen sincronizada
#@version 1.0 - Montar imagen sincronizable
#@author  Irina Gomez
#@date   2013-05-23
#*/ ##
BASEDIR=/opt/opengnsys
REPODIR="$BASEDIR/images"
# Cargamos los mensajes en el idioma del sistema.
# Comprobamos que el fichero de idioma existe. Si no "es_ES" por defecto.
ls $BASEDIR/client/etc/lang.$LANG.conf &>/dev/null
[ $? -eq 0 ] || LANG="es_ES"
source $BASEDIR/client/etc/lang.$LANG.conf


PROG="$(basename $0)"
# Si se solicita, mostrar ayuda.
if [ "$*" == "help" ]; then
    echo -e " $PROG: $MSG_HELP_ogMountImage \n" \
            "$MSG_FORMAT: $PROG nombre_image [ img|diff ] \n" \
            "base -> $PROG Windows7 \n" \
	    "diff -> $PROG Ubuntu12 diff"
   exit 0
fi

[ $# -lt 1 ] && echo -e "$PROG: Error: $MSG_ERR_FORMAT \n     $MSG_FORMAT: $PROG image [ img | diff ]" && exit 1

if [ "$USER" != "root" ]; then
        echo "$PROG: Error: solo ejecutable por root" >&2
        exit 1
fi

[ "$2" == "" -o "$2" == "img" ] && IMGEXT="img" || IMGEXT="img.diff"

# Comprobamos que existe imagen
IMGFILE="$REPODIR/$1.$IMGEXT"
[ ! -f $IMGFILE ] && echo "$PROG: Error: $MSG_ERR_NOTFOUND $1 $IMGEXT" && exit 2


# Comprobar que la imagen  es sincronizable
file $IMGFILE | grep -i -e " BTRFS Filesystem " >/dev/null && IMGFS=BTRFS
file $IMGFILE | grep -i -e " ext4 filesystem " >/dev/null && IMGFS=EXT4
if [ "$IMGFS" != "BTRFS" -a "$IMGFS" != "EXT4" ] ; then
	echo "$PROG: Error: $MSG_ERR_DONTSYNC_IMAGE $1 $2"
	exit 71
fi

MOUNTDIR="$REPODIR/mount/$1"
[ "$IMGEXT" == "img.diff" ] && MOUNTDIR="$MOUNTDIR.${IMGEXT#*\.}"
mkdir -p "$MOUNTDIR"

# Comprobamos si la imagen esta montada y si es así nos salimos.
df |grep "$MOUNTDIR$"  2>&1  >/dev/null && echo "$MOUNTDIR" && exit 0

if [ "$IMGFS" == "EXT4" ] ; then
	mount -t ext4 "$IMGFILE" "$MOUNTDIR"
else
	mount -o compress=lzo  "$IMGFILE" "$MOUNTDIR"
fi
[ $? -eq 0 ] || ( echo "$MSG_ERR_DONTMOUNT_IMAGE  $1 $2" ; exit 70)
echo  "$MOUNTDIR"

